comonad-4.0: Comonads

Portability | non-portable (fundeps, MPTCs)
Stability | experimental
Maintainer | Edward Kmett <ekmett@gmail.com>
Safe Haskell | Trustworthy

Control.Comonad.Traced.Class

Description

# Documentation

class Comonad w => ComonadTraced m w | w -> m where Source

Methods

trace :: m -> w a -> aSource

Instances

ComonadTraced m w => ComonadTraced m (IdentityT w) |
ComonadTraced m w => ComonadTraced m (StoreT s w) |
ComonadTraced m w => ComonadTraced m (EnvT e w) |
(Comonad w, Monoid m) => ComonadTraced m (TracedT m w) |

traces :: ComonadTraced m w => (a -> m) -> w a -> aSource